/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -i configurationtype.h -i sigmodelstype.h -i vendormodelstype.h -p proxy dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */

#ifndef PROXY_H_1600719816
#define PROXY_H_1600719816

#include <QtCore/QObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>
#include <QtDBus/QtDBus>
#include "configurationtype.h"
#include "sigmodelstype.h"
#include "vendormodelstype.h"

/*
 * Proxy class for interface org.bluez.mesh.Element1
 */
class OrgBluezMeshElement1Interface: public QDBusAbstractInterface
{
    Q_OBJECT
public:
    static inline const char *staticInterfaceName()
    { return "org.bluez.mesh.Element1"; }

public:
    OrgBluezMeshElement1Interface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

    ~OrgBluezMeshElement1Interface();

    Q_PROPERTY(uchar Index READ index)
    inline uchar index() const
    { return qvariant_cast< uchar >(property("Index")); }

    Q_PROPERTY(ushort Location READ location)
    inline ushort location() const
    { return qvariant_cast< ushort >(property("Location")); }

    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType Models READ models)
    inline Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType models() const
    { return qvariant_cast< Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType >(property("Models")); }

    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType VendorModels READ vendorModels)
    inline Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType vendorModels() const
    { return qvariant_cast< Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType >(property("VendorModels")); }

public Q_SLOTS: // METHODS
    inline QDBusPendingReply<> DevKeyMessageReceived(ushort source, bool remote, ushort net_index, const QByteArray &data)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(source) << QVariant::fromValue(remote) << QVariant::fromValue(net_index) << QVariant::fromValue(data);
        return asyncCallWithArgumentList(QLatin1String("DevKeyMessageReceived"), argumentList);
    }

    inline QDBusPendingReply<> MessageReceived(ushort source, ushort key_index, const QDBusVariant &destination, const QByteArray &data)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(source) << QVariant::fromValue(key_index) << QVariant::fromValue(destination) << QVariant::fromValue(data);
        return asyncCallWithArgumentList(QLatin1String("MessageReceived"), argumentList);
    }

    inline QDBusPendingReply<> UpdateModelConfiguration(ushort model_id, Oscl::Qt::DBus::BlueZ::Mesh::Element1::ConfigurationType config)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(model_id) << QVariant::fromValue(config);
        return asyncCallWithArgumentList(QLatin1String("UpdateModelConfiguration"), argumentList);
    }

Q_SIGNALS: // SIGNALS
};

namespace org {
  namespace bluez {
    namespace mesh {
      typedef ::OrgBluezMeshElement1Interface Element1;
    }
  }
}
#endif
